package cerebral.parallelCoordinates;

import java.util.Iterator;
import java.util.List;

import prefuse.Display;
import prefuse.visual.VisualItem;

public class DataFilterer {
	private Display d;

	public DataFilterer(Display d) {
		this.d = d;
	}

	public boolean passesFilters(VisualItem item) {
		List values = (List) item.get(ParallelCoordinates.VALUES);
		
		Iterator filtersIt = d.getVisualization().getVisualGroup(ParallelCoordinates.FILTERS).tuples();
		while (filtersIt.hasNext()){
		    VisualItem filter = (VisualItem) filtersIt.next();
		    double value = (
		            (Double) values.get(
		            ((VisualItem)filter.get(ParallelCoordinates.COORDINATE)).getRow()
		            ))
		            .doubleValue();
		    double top = filter.getDouble(ParallelCoordinates.TOP);
		    double bottom = filter.getDouble(ParallelCoordinates.BOTTOM);
		    if (value < bottom || value > top){
		        return false;
		    }
		}
		return true;
	}
	

}
