package cerebral.parallelCoordinates.render;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.font.FontRenderContext;
import java.awt.font.TextLayout;
import java.awt.geom.Rectangle2D;

import prefuse.render.Renderer;
import prefuse.util.ColorLib;
import prefuse.util.FontLib;

public class RenderUtil {
    private static  Rectangle2D rect = new Rectangle2D.Float();

    public static void drawText(Graphics2D g, String label, Color bg, double x, float y) {
        FontRenderContext frc = Renderer.DEFAULT_GRAPHICS
                .getFontRenderContext();
        TextLayout textLayout = new TextLayout(label, FontLib.getFont("Verdana", 14), frc);
        Rectangle2D textBounds = textLayout.getBounds();
        g.setFont(FontLib.getFont("Verdana", 14));
        rect.setRect(x + 4, y - textBounds.getHeight(), textBounds.getWidth(),
                textBounds.getHeight());
        g.setColor(ColorLib.getColor(bg.getRed(), bg.getGreen(), bg.getBlue(), 200));
        g.fill(rect);
        g.setColor(Color.black);
        g.drawString(label, (float) (x + 4), y);
    }
    
    public static void drawTextAtTop(Graphics2D g, String label, Color bg, Color fg,  double x, float y) {
        if (label.length() > 0){
        FontRenderContext frc = Renderer.DEFAULT_GRAPHICS
                .getFontRenderContext();
        
        TextLayout textLayout = new TextLayout(label, FontLib.getFont("Verdana", 14), frc);
        Rectangle2D textBounds = textLayout.getBounds();
        g.setFont(FontLib.getFont("Verdana", 14));
        rect.setRect(x + 4, y, textBounds.getWidth(),
                textBounds.getHeight());
        g.setColor(ColorLib.getColor(bg.getRed(), bg.getGreen(), bg.getBlue(), 200));
        g.fill(rect);
        g.setColor(fg);
        g.drawString(label, (float) (x + 4), (float) (y + textBounds.getHeight()/2));
        }
    }

}
